<template>
    <div>
        <MdButton class="md-icon-button" @click="openMenu()">
            <slot name="button"></slot>
        </MdButton>
        <MdMenu :md-active.sync="open">
            <MdMenuContent style="z-index: 2000">
                <slot></slot>
            </MdMenuContent>
        </MdMenu>
    </div>
</template>
<script>
  import Vue from 'vue';
  import { MdMenu } from 'vue-material/dist/components'
  import jslog from 'js-logger';
  import { addAfterEach, removeAfterEach } from '../router';

  const log = jslog.get('RoutableMenu');

  Vue.use(MdMenu);

  /* eslint-disable no-debugger */

  export default {
    props: {
      noRoute: {
        type: Boolean,
        default: false
      }
    },
    data() {
      return {
        isOpen: false,
        afterHookSet: false
      }
    },
    computed: {
      open: {
        get() {
          return this.isOpen;
        },
        set(open) {
            if(!this.noRoute) {
              const query = {};
              const { modal } = this.$route.query;
              //close
              if (!open) {
                if (modal === 'T') {
                  log.info(`unset modal route, current modal = ${modal}`);
                  this.$router.go(-1);
                }
              } else {
                // open
                query.modal = 'T';
                if (!modal) {
                  log.info(`set modal route, current modal = ${modal}`);
                  this.$router.push({ query });
                }
              }
            }
          this.isOpen = open;
        }
      }
    },
    methods: {
      openMenu() {
        this.open = true;
      },
      after(to, from) {
        if (this.isOpen && from.query.modal === 'T' && !to.query.modal && to.path === from.path) {
          log.info('remove modal');
          this.open = false;
        }
      }
    },
    mounted() {
      if (this.afterHookSet) return;
      this.afterHookSet = true;
      log.info('add...');
      addAfterEach(this.after);
    },
    destroyed() {
      log.info('remove hook...');
      removeAfterEach(this.after);
    }
  };
</script>
